@echo off
set title=Djuult's Steam Account Switcher 1.2.2
title %title%
REM !!!!!PLEASE READ!!!!! Set 'steamLocation' to where you have Steam installed, and set
REM !!!!!PLEASE READ!!!!! (and add more if wanted) the variables 5 lines below this comment
REM !!!!!PLEASE READ!!!!! to the credentials of your Steam Accounts, with the wanted
REM !!!!!PLEASE READ!!!!! associated 'accountNumber'.
set steamLocation=C:\Program Files (x86)\Steam
goto start

:setNameAndPassword
if %accountNumber%==1 set accountName=ACCOUNT_ONE_USERNAME
if %accountNumber%==1 set accountPassword=ACCOUNT_ONE_PASSWORD
if %accountNumber%==2 set accountName=ACCOUNT_TWO_USERNAME
if %accountNumber%==2 set accountPassword=ACCOUNT_TWO_PASSWORD

if %accountName%==.. (
	set printCounter=-1
	goto enterAccount
)
if not %printCounter%==-1 (
	goto printAccount
)
goto signIn

:start
set shutdownStatus=-1
set timesWaited=0
set accountName=0
set printCounter=0

:checkIfRunning
tasklist /fi "imagename eq steam.exe" 2> nul | find /i /n "steam.exe" > nul
if not %ERRORLEVEL%==0 (
	if not %shutdownStatus%==-1 (
		set shutdownStatus=0
	)
	goto notRunning
)
if "%ERRORLEVEL%"=="0" (
	if %shutdownStatus%==1 (
		goto waitForShutdown
	)
	if %shutdownStatus%==2 (
		set shutdownStatus=3
		echo Steam is still running, forcing shutdown...
		taskkill /f /im steam.exe
		goto checkIfRunning
	)
	if %shutdownStatus%==-1 (
		set shutdownStatus=1
		echo Steam is already running, shutting it down properly and waiting 10 seconds, before forcing... (Steam.exe -shutdown)
		start "" "%steamLocation%\Steam.exe" -shutdown
		:waitForShutdown
		if %timesWaited% lss 5 (
			set /a timesWaited+=1
			timeout 2 > nul
			goto checkIfRunning
		)
		set shutdownStatus=2
		goto checkIfRunning
	)
	echo Steam could not be shut down. Continue program?
	pause
)

:notRunning
if %shutdownStatus%==-1 echo Steam is not already running.
if %shutdownStatus%==0 echo Steam has been shut down.

:printAccounts
set /a printCounter=printCounter+1
set accountName=..
set accountNumber=%printCounter%
goto setNameAndPassword

:printAccount
echo Account %printCounter%: %accountName%
goto printAccounts

:enterAccount
SET accountName=.
set /p accountNumber=Please enter the number of the account to sign in:
goto setNameAndPassword
if %accountName%==. (
	echo Invalid account number.
	goto enterAccount
)

:signIn
echo Signing into new session of Steam... (Steam.exe -login %accountName% ******)
start "" "%steamLocation%\Steam.exe" -login %accountName% %accountPassword%
echo Steam should be starting and logging in.
pause